// DXScreen.h: interface for the CDXScreen class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DXSCREEN_H__F4721AE4_5ADC_11D3_BB14_0080C81F9D2D__INCLUDED_)
#define AFX_DXSCREEN_H__F4721AE4_5ADC_11D3_BB14_0080C81F9D2D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CDXScreen : public CObject  
{
	DECLARE_DYNAMIC (CDXScreen);

public:
	CDXScreen ();
	virtual ~CDXScreen ();

	//     DirectDraw
	virtual BOOL Create (CWnd* pWnd, UINT cx = 0, UINT cy = 0);
	virtual BOOL CreateSurfaces (void);
	virtual void Destroy (void);
	virtual void DestroySurfaces (void);

	//    DC  
	virtual HDC GetPrimaryDC (void);
	virtual BOOL ReleasePrimaryDC (HDC hdc);
	virtual HDC GetBackDC (void);
	virtual BOOL ReleaseBackDC (HDC hdc);

	//      
	virtual BOOL Draw (void);

	//    
	virtual LPDIRECTDRAW2 GetDD2 (void) {return m_lpDD2;};
	virtual LPDIRECTDRAWSURFACE3 GetPS3 (void) {return m_lpDDSPrimary3;};
	virtual LPDIRECTDRAWSURFACE3 GetBS3 (void) {return m_lpDDSBack3;};
	virtual LPDIRECTDRAWCLIPPER GetClipper (void) {return m_lpDDClipper;};
	virtual UINT GetWidth (void) {return m_Rect.right - m_Rect.left;};
	virtual UINT GetHeight (void) {return m_Rect.bottom - m_Rect.top;};
	virtual CWnd* GetWnd (void) {return m_pWnd;};

protected:
	LPDIRECTDRAW2 m_lpDD2;					// DirectDraw object
	LPDIRECTDRAWSURFACE3 m_lpDDSPrimary3;	// DirectDraw primary surface
	LPDIRECTDRAWSURFACE3 m_lpDDSBack3;		// DirectDraw secondary surface
	LPDIRECTDRAWCLIPPER m_lpDDClipper;		// DirectDraw clipper
	CWnd* m_pWnd;							// 
	UINT m_cx, m_cy;
	RECT m_Rect;							//    
											// (  )
	CRITICAL_SECTION m_cs;
};

#endif // !defined(AFX_DXSCREEN_H__F4721AE4_5ADC_11D3_BB14_0080C81F9D2D__INCLUDED_)
