// DXSound.h: interface for the CDXSound class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DXSOUND_H__636E76E8_5DF9_11D3_AD93_006052098A4E__INCLUDED_)
#define AFX_DXSOUND_H__636E76E8_5DF9_11D3_AD93_006052098A4E__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

typedef struct waveinfoca_tag
{
    WAVEFORMATEX         *pwfx;				/* Wave Format data structure */
    HMMIO                hmmio;				/* MM I/O handle for the WAVE */
    MMCKINFO             mmck;				/* Multimedia RIFF chunk */
    MMCKINFO             mmckInRIFF;	    /* Use in opening a WAVE file */
} WAVEINFOCA, *LPWAVEINFOCA;

class CDXSound : public CObject
{
	DECLARE_DYNAMIC (CDXSound);

public:
	CDXSound ();
	virtual ~CDXSound ();

	virtual BOOL Load (CWnd* pWnd, UINT idFilename);
	virtual BOOL Load (CWnd* pWnd, LPCSTR szFilename);
	virtual void Destroy (void);

	virtual BOOL Play (BOOL Loop = FALSE);
	virtual BOOL Stop (void);
	virtual BOOL Rewind (void);

	virtual BOOL IsPlaying (void);
	virtual BOOL IsLost (void);

protected:
	LPDIRECTSOUND m_pDS;
	LPDIRECTSOUNDBUFFER	m_pDSBStreamBuffer;
	WAVEINFOCA m_wiWave;
	CWnd* m_pWnd;

	virtual BOOL LoadHelper (CWnd* pWnd, LPCSTR szFilename,	BOOL bResource);
};

#endif // !defined(AFX_DXSOUND_H__636E76E8_5DF9_11D3_AD93_006052098A4E__INCLUDED_)
