// DXSprite.h: interface for the CDXSprite class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DXSPRITE_H__F4721AE5_5ADC_11D3_BB14_0080C81F9D2D__INCLUDED_)
#define AFX_DXSPRITE_H__F4721AE5_5ADC_11D3_BB14_0080C81F9D2D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "DXImage.h"

class CDXSprite : public CObject  
{
	DECLARE_DYNAMIC (CDXSprite);

public:
	CDXSprite ();
	virtual ~CDXSprite();

	//   (size -  )
	virtual BOOL Create (LPDIRECTDRAW2 lpDD, int x, int y, UINT cx, UINT cy,
		DWORD size = 1, LPCTSTR szName = _T(""));
	
	//  
	virtual BOOL LoadFile (LPDIRECTDRAW2 lpDD, LPCTSTR szBitmap, int x, int y,
		DWORD size = 1, LPCTSTR szName = _T(""));
	virtual BOOL LoadResource (LPDIRECTDRAW2 lpDD, LPCTSTR szBitmap, int x, int y,
		DWORD size = 1, LPCTSTR szName = _T(""));
	
	//  
	virtual void Destroy (void);

	//  
	virtual BOOL FastDraw (LPDIRECTDRAWSURFACE3 lpDDDestSurface,
		DWORD dwFlags = DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);
	virtual BOOL Draw (LPDIRECTDRAWSURFACE3 lpDDDestSurface,
		DWORD dwFlags = DDBLT_WAIT | DDBLT_KEYSRC, LPDDBLTFX lpDDBltFx = NULL);

	//   
	virtual void SetFrame (DWORD dwNewFrame);
	virtual void NextFrame (BOOL bLoop = TRUE);
	virtual DWORD GetFrame (void);

	//  
	virtual void SetPos (int x, int y);
	
	//  
	virtual int GetWidth (void);
	virtual int GetHeight (void);
	virtual BOOL IsLoaded (void);
	virtual CString GetName (void);
	virtual CDXImage& GetImage (void) {return m_imgImage;};

protected:
	CDXImage m_imgImage;	//  
	DWORD m_dwFrame;		//   
	DWORD m_dwSize;			//    
	int m_x;				//   (x)
	int m_y;				//   (y)
	CString m_strName;		//  
	CRITICAL_SECTION m_cs;	//  

	void DestroyHelper (void);	//  
};

#endif // !defined(AFX_DXSPRITE_H__F4721AE5_5ADC_11D3_BB14_0080C81F9D2D__INCLUDED_)
