// KittyDlg.h : header file
//

#if !defined(AFX_KITTYDLG_H__A00BF2E6_5A1F_11D3_BB14_0080C81F9D2D__INCLUDED_)
#define AFX_KITTYDLG_H__A00BF2E6_5A1F_11D3_BB14_0080C81F9D2D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "DXSprite.h"
#include "DXScreen.h"
#include "DXSound.h"

/////////////////////////////////////////////////////////////////////////////
// CKittyDlg dialog

class CKittyDlg : public CDialog
{
friend UINT RunThread (LPVOID pParam); //    

// Construction
public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	CKittyDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CKittyDlg)
	enum { IDD = IDD_KITTY_DIALOG };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CKittyDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	HRGN m_hRgn;
	CToolTipCtrl m_tooltip;
	CDXScreen m_Screen;
	CDXSprite m_Logo;
	CDXSprite m_Clock;
	CDXSprite m_Arrows;
	CDXSound m_HalfSound;
	CString m_strStartupFolder;
	CStringList m_PersonList;
	int m_ClockSize;			//  
	BOOL m_bSound;
	HANDLE m_eventStopped;		// EVENT      
	HANDLE m_eventRequest;		// EVENT      
	HANDLE m_thread;			//   

protected:
	void Draw (void);
	void DrawClock (WORD hour, WORD minute, WORD second);
	void LoadPersones (void);
	
	BOOL Start (void);		//   
	BOOL Stop (void);		//   
	UINT Run (void);		//  

	// Generated message map functions
	//{{AFX_MSG(CKittyDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTime();
	afx_msg void OnExit();
	afx_msg void OnMove();
	afx_msg void OnAbout();
	afx_msg void OnSound();
	afx_msg void OnAutostart();
	afx_msg void OnOk ();
	afx_msg void OnCancel ();
	afx_msg BOOL OnEraseBkgnd (CDC* pDC);
	afx_msg void OnNcRButtonDown (UINT nHitTest, CPoint point);
	afx_msg void OnNcPaint ();
	afx_msg void OnNcLButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG
	afx_msg UINT OnNcHitTest (CPoint point);
	afx_msg void OnSurf (UINT nId);
	afx_msg void OnPersonSelect (UINT nId);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_KITTYDLG_H__A00BF2E6_5A1F_11D3_BB14_0080C81F9D2D__INCLUDED_)
