// RegistryStuff.cpp : implementation file
//

#include "stdafx.h"
#include "RegistryStuff.h"

int strtolx (LPCTSTR str)
{
	ASSERT (str != NULL);
	char *endptr;
	if (str [0] == '\0')
		return -1;
	long i = strtol (str, &endptr, 10);
	if (*endptr != '\0' || i == LONG_MAX || i == LONG_MIN)
		return -1;
	return (int) i;
}

CString GetProfileStringEx (LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszDefault)
{
	ASSERT (lpszSection != NULL);
	ASSERT (lpszEntry != NULL);

	//       
	CString strSection = _T("Software");
	strSection += _T("\\");
	strSection += AfxGetApp ()->m_pszRegistryKey;
	strSection += _T("\\");
	strSection += AfxGetApp ()->m_pszProfileName;
	strSection += _T("\\");
	strSection += lpszSection;

	HKEY hKey;
	if (RegOpenKey (HKEY_CURRENT_USER, strSection, &hKey) != ERROR_SUCCESS)
		return lpszDefault;

	CString strValue;
	DWORD dwType, dwCount;
	LONG lResult = RegQueryValueEx (hKey, lpszEntry, NULL, &dwType,
		NULL, &dwCount);
	if (lResult == ERROR_SUCCESS && dwType == REG_SZ) {
		lResult = RegQueryValueEx (hKey, lpszEntry, NULL, &dwType,
			(LPBYTE)strValue.GetBuffer(dwCount/sizeof(TCHAR)), &dwCount);
		strValue.ReleaseBuffer();
	}

	RegCloseKey (hKey);

	if (lResult == ERROR_SUCCESS && dwType == REG_SZ)
		return strValue;
	else
		return lpszDefault;
}

int GetProfileIntEx (LPCTSTR lpszSection, LPCTSTR lpszEntry, int nDefault)
{
	ASSERT (lpszSection != NULL);
	ASSERT (lpszEntry != NULL);

	TCHAR szDefault [34];
	_itoa (nDefault, szDefault, 10);
	int n = strtolx (GetProfileStringEx (lpszSection, lpszEntry, szDefault));
	if (n == -1)
		return nDefault;
	return n;
}

BOOL WriteProfileIntEx (LPCTSTR lpszSection, LPCTSTR lpszEntry, int nValue)
{
	ASSERT (lpszSection != NULL);
	ASSERT (lpszEntry != NULL);

	TCHAR szValue [34];
	_itoa (nValue, szValue, 10);
	return WriteProfileStringEx (lpszSection, lpszEntry, szValue);
}

BOOL WriteProfileStringEx (LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszValue)
{
	ASSERT (lpszSection != NULL);
	ASSERT (lpszEntry != NULL);
	ASSERT (lpszValue != NULL);

	return AfxGetApp ()->WriteProfileString (lpszSection, lpszEntry, lpszValue);
}
